## imhex 1.30.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

# Options
option(IMHEX_USE_BUNDLED_CA "Use the CA bundle in romfs instead of the system one" OFF)
option(IMHEX_PLUGINS_IN_SHARE "Put the plugins in share/imhex/plugins instead of lib[..]/imhex/plugins" OFF)
option(IMHEX_STRIP_RELEASE "Strip the release builds" ON)
option(IMHEX_OFFLINE_BUILD "Enable offline build" OFF)
option(IMHEX_IGNORE_BAD_CLONE "Disable the bad clone prevention checks" OFF)
option(IMHEX_PATTERNS_PULL_MASTER "Download latest files from master branch of the ImHex-Patterns repo" OFF)
option(IMHEX_IGNORE_BAD_COMPILER "Allow compiling with an unsupported compiler" OFF)
option(IMHEX_USE_GTK_FILE_PICKER "Use GTK file picker instead of xdg-desktop-portals" OFF)
option(IMHEX_DISABLE_STACKTRACE "Disables support for printing stack traces" OFF)

# Basic compiler and cmake configurations
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
set(IMHEX_BASE_FOLDER ${CMAKE_CURRENT_SOURCE_DIR})
set(CMAKE_MODULE_PATH "${IMHEX_BASE_FOLDER}/cmake/modules")
include("${IMHEX_BASE_FOLDER}/cmake/build_helpers.cmake")

# Setup project
loadVersion(IMHEX_VERSION)
setVariableInParent(IMHEX_VERSION ${IMHEX_VERSION})
project(imhex
        LANGUAGES C CXX VERSION ${IMHEX_VERSION}
        DESCRIPTION "The ImHex Hex Editor"
        HOMEPAGE_URL "https://imhex.werwolv.net"
)

# Make sure project is configured correctly
setDefaultBuiltTypeIfUnset()
detectBadClone()
verifyCompiler()

# List plugin names here. Project name must match folder name
set(PLUGINS
    builtin
    windows
)

# Add various defines
detectOS()
detectArch()
addDefines()
configurePackingResources()
setUninstallTarget()
addBundledLibraries()

# Add ImHex sources
add_subdirectory(lib/libimhex)
add_subdirectory(main)
add_custom_target(imhex_all ALL DEPENDS main libimhex)

# Add unit tests
enable_testing()
add_subdirectory(tests EXCLUDE_FROM_ALL)

# Configure packaging
createPackage()
generatePDBs()

=== main/CMakeLists.txt ===
project(main)

add_executable(main ${APPLICATION_TYPE}
    source/main.cpp
    source/crash_handlers.cpp

    source/window/window.cpp
    source/window/win_window.cpp
    source/window/macos_window.cpp
    source/window/linux_window.cpp

    source/init/splash_window.cpp
    source/init/tasks.cpp

    ${IMHEX_ICON}
)

target_include_directories(main PUBLIC include)
setupCompilerFlags(main)

set(LIBROMFS_RESOURCE_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/romfs)
set(LIBROMFS_PROJECT_NAME imhex)
add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../lib/external/libromfs ${CMAKE_CURRENT_BINARY_DIR}/main/libromfs EXCLUDE_FROM_ALL)
set_target_properties(${LIBROMFS_LIBRARY} PROPERTIES POSITION_INDEPENDENT_CODE ON)

set_target_properties(main PROPERTIES
        OUTPUT_NAME "imhex"
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/..
        CXX_VISIBILITY_PRESET hidden
        POSITION_INDEPENDENT_CODE ON)

add_compile_definitions(IMHEX_PROJECT_NAME="${PROJECT_NAME}")

target_link_libraries(main PRIVATE libromfs-imhex libimhex ${FMT_LIBRARIES})
if (WIN32)
    target_link_libraries(main PRIVATE usp10 wsock32 ws2_32 Dwmapi.lib)
else ()
    target_link_libraries(main PRIVATE pthread)
endif ()

if (APPLE)
    add_compile_definitions(GL_SILENCE_DEPRECATION)
endif ()

=== tests/CMakeLists.txt ===
project(unit_tests)

add_compile_definitions(IMHEX_PROJECT_NAME="${PROJECT_NAME}")

add_custom_target(unit_tests DEPENDS helpers algorithms)
add_subdirectory(common)

add_subdirectory(helpers)
add_subdirectory(algorithms)

=== lib/libimhex/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(libimhex)

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_SHARED_LIBRARY_PREFIX "")

set(LIBIMHEX_SOURCES
        source/api/event.cpp
        source/api/imhex_api.cpp
        source/api/content_registry.cpp
        source/api/task.cpp
        source/api/keybinding.cpp
        source/api/plugin_manager.cpp
        source/api/localization.cpp
        source/api/project_file_manager.cpp
        source/api/theme_manager.cpp
        source/api/layout_manager.cpp

        source/data_processor/attribute.cpp
        source/data_processor/link.cpp
        source/data_processor/node.cpp

        source/helpers/utils.cpp
        source/helpers/fs.cpp
        source/helpers/magic.cpp
        source/helpers/crypto.cpp
        source/helpers/http_requests.cpp
        source/helpers/opengl.cpp
        source/helpers/patches.cpp
        source/helpers/encoding_file.cpp
        source/helpers/logger.cpp
        source/helpers/stacktrace.cpp
        source/helpers/tar.cpp

        source/providers/provider.cpp

        source/ui/imgui_imhex_extensions.cpp
        source/ui/view.cpp
        source/ui/popup.cpp
)

if (APPLE)
    set(OSX_11_0_SDK_PATH  /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX11.0.sdk)
    if (NOT CMAKE_OSX_SYSROOT)
        if (IS_DIRECTORY ${OSX_11_0_SDK_PATH})
            set(CMAKE_OSX_SYSROOT ${OSX_11_0_SDK_PATH})
        else ()
            message(WARNING "CMAKE_OSX_SYSROOT not set and macOS 10.9 SDK not found! Using default one.")
        endif ()
    endif ()

    set(LIBIMHEX_SOURCES ${LIBIMHEX_SOURCES} source/helpers/utils_macos.m)
endif ()

add_compile_definitions(IMHEX_PROJECT_NAME="${PROJECT_NAME}")

add_library(libimhex SHARED ${LIBIMHEX_SOURCES})
set_target_properties(libimhex PROPERTIES POSITION_INDEPENDENT_CODE ON)
setupCompilerFlags(libimhex)


target_include_directories(libimhex PUBLIC include ${XDGPP_INCLUDE_DIRS} ${MBEDTLS_INCLUDE_DIRS} ${CAPSTONE_INCLUDE_DIRS} ${MAGIC_INCLUDE_DIRS} ${LLVM_INCLUDE_DIRS} ${FMT_INCLUDE_DIRS} ${CURL_INCLUDE_DIRS} ${YARA_INCLUDE_DIRS} ${LIBBACKTRACE_INCLUDE_DIRS})
target_link_directories(libimhex PUBLIC ${MBEDTLS_LIBRARY_DIR} ${CAPSTONE_LIBRARY_DIRS} ${MAGIC_LIBRARY_DIRS})

if (WIN32)
    target_link_options(libimhex PRIVATE -Wl,--export-all-symbols)
elseif (APPLE)
    find_library(FOUNDATION NAMES Foundation)
    target_link_libraries(libimhex PUBLIC ${FOUNDATION})
endif ()

target_link_libraries(libimhex PRIVATE ${FMT_LIBRARIES})
target_link_libraries(libimhex PUBLIC dl imgui ${NFD_LIBRARIES} magic ${CAPSTONE_LIBRARIES} LLVMDemangle microtar ${NLOHMANN_JSON_LIBRARIES} ${YARA_LIBRARIES} ${LIBCURL_LIBRARIES} ${MBEDTLS_LIBRARIES} ${LIBBACKTRACE_LIBRARIES} libpl libpl-gen ${MINIAUDIO_LIBRARIES} libwolv-utils libwolv-io libwolv-hash libwolv-net libwolv-containers)

=== plugins/builtin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
# Change this to the name of your plugin #
project(builtin)

# Add your source files here #
add_library(${PROJECT_NAME} SHARED
        source/plugin_builtin.cpp

        source/content/background_services.cpp
        source/content/command_palette_commands.cpp
        source/content/communication_interface.cpp
        source/content/data_inspector.cpp
        source/content/pl_builtin_functions.cpp
        source/content/pl_pragmas.cpp
        source/content/pl_visualizers.cpp
        source/content/settings_entries.cpp
        source/content/tools_entries.cpp
        source/content/data_processor_nodes.cpp
        source/content/ui_items.cpp
        source/content/providers.cpp
        source/content/views.cpp
        source/content/data_formatters.cpp
        source/content/main_menu_items.cpp
        source/content/welcome_screen.cpp
        source/content/data_visualizers.cpp
        source/content/events.cpp
        source/content/hashes.cpp
        source/content/global_actions.cpp
        source/content/themes.cpp
        source/content/recent.cpp
        source/content/file_handlers.cpp
        source/content/project.cpp

        source/content/providers/file_provider.cpp
        source/content/providers/gdb_provider.cpp
        source/content/providers/disk_provider.cpp
        source/content/providers/intel_hex_provider.cpp
        source/content/providers/motorola_srec_provider.cpp
        source/content/providers/memory_file_provider.cpp

        source/content/views/view_hex_editor.cpp
        source/content/views/view_pattern_editor.cpp
        source/content/views/view_pattern_data.cpp
        source/content/views/view_hashes.cpp
        source/content/views/view_information.cpp
        source/content/views/view_about.cpp
        source/content/views/view_tools.cpp
        source/content/views/view_data_inspector.cpp
        source/content/views/view_disassembler.cpp
        source/content/views/view_bookmarks.cpp
        source/content/views/view_patches.cpp
        source/content/views/view_command_palette.cpp
        source/content/views/view_settings.cpp
        source/content/views/view_data_processor.cpp
        source/content/views/view_yara.cpp
        source/content/views/view_constants.cpp
        source/content/views/view_store.cpp
        source/content/views/view_diff.cpp
        source/content/views/view_provider_settings.cpp
        source/content/views/view_find.cpp
        source/content/views/view_theme_manager.cpp

        source/content/helpers/math_evaluator.cpp
        source/content/helpers/notification.cpp

        source/ui/hex_editor.cpp
        source/ui/pattern_drawer.cpp
)

# Add additional include directories here #
target_include_directories(${PROJECT_NAME} PRIVATE include)

# Add additional libraries here #
target_link_libraries(${PROJECT_NAME} PRIVATE libimhex ${FMT_LIBRARIES})

# ---- No need to change anything from here downwards unless you know what you're doing ---- #

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_SHARED_LIBRARY_PREFIX "")
set(CMAKE_SHARED_LIBRARY_SUFFIX ".hexplug")

if (WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--allow-multiple-definition -fvisibility=hidden")
endif()

add_compile_definitions(IMHEX_PROJECT_NAME="${PROJECT_NAME}")
set_target_properties(${PROJECT_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
setupCompilerFlags(${PROJECT_NAME})

set(LIBROMFS_RESOURCE_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/romfs)
set(LIBROMFS_PROJECT_NAME ${PROJECT_NAME})
add_subdirectory(../../lib/external/libromfs ${CMAKE_CURRENT_BINARY_DIR}/libromfs)
set_target_properties(${LIBROMFS_LIBRARY} PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_link_libraries(${PROJECT_NAME} PRIVATE ${LIBROMFS_LIBRARY})

=== plugins/windows/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# Change this to the name of your plugin #
project(windows)

# Add your source files here #
if (WIN32)

    add_library(${PROJECT_NAME} SHARED
            source/plugin_windows.cpp

            source/views/view_tty_console.cpp

            source/content/ui_items.cpp
            source/content/settings_entries.cpp
            source/content/providers.cpp

            source/content/providers/process_memory_provider.cpp
    )

    # Add additional include directories here #
    target_include_directories(${PROJECT_NAME} PRIVATE include)
    # Add additional libraries here #
    target_link_libraries(${PROJECT_NAME} PRIVATE libimhex ${FMT_LIBRARIES})


    # ---- No need to change anything from here downwards unless you know what you're doing ---- #

    set(CMAKE_CXX_STANDARD 23)
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
    set(CMAKE_SHARED_LIBRARY_SUFFIX ".hexplug")

    if (WIN32)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--allow-multiple-definition -fvisibility=hidden")
    endif()

    add_compile_definitions(IMHEX_PROJECT_NAME="${PROJECT_NAME}")
    set_target_properties(${PROJECT_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
    setupCompilerFlags(${PROJECT_NAME})

    set(LIBROMFS_RESOURCE_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/romfs)
    set(LIBROMFS_PROJECT_NAME ${PROJECT_NAME})
    add_subdirectory(../../lib/external/libromfs ${CMAKE_CURRENT_BINARY_DIR}/libromfs)
    set_target_properties(${LIBROMFS_LIBRARY} PROPERTIES POSITION_INDEPENDENT_CODE ON)
    target_link_libraries(${PROJECT_NAME} PRIVATE ${LIBROMFS_LIBRARY})

endif ()

=== tests/common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(tests_common)

add_library(tests_common STATIC
        source/main.cpp
)
target_include_directories(tests_common PUBLIC include)
target_link_libraries(tests_common PUBLIC libimhex ${FMT_LIBRARIES})

=== tests/helpers/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(helpers_test)
set(TEST_CATEGORY Helpers)

# Add new tests here #
set(AVAILABLE_TESTS
    # Common
        TestSucceeding
        TestFailing
        TestProvider_read
        TestProvider_write

    # Net
        StoreAPI
        TipsAPI
        ContentAPI

    # File
        FileAccess

    # Utils
        SplitStringAtChar
        SplitStringAtString
        ExtractBits
)


add_executable(${PROJECT_NAME}
        source/common.cpp
        source/file.cpp
        source/net.cpp
        source/utils.cpp
)


# ---- No need to change anything from here downwards unless you know what you're doing ---- #

target_include_directories(${PROJECT_NAME} PRIVATE include)
target_link_libraries(${PROJECT_NAME} PRIVATE libimhex tests_common ${FMT_LIBRARIES})

set_target_properties(${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

foreach (test IN LISTS AVAILABLE_TESTS)
    add_test(NAME "${TEST_CATEGORY}/${test}" COMMAND ${PROJECT_NAME} "${test}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
endforeach ()
add_dependencies(unit_tests ${PROJECT_NAME})

=== lib/external/imgui/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(imgui)

set(CMAKE_CXX_STANDARD 17)

find_package(PkgConfig REQUIRED)
find_package(Freetype REQUIRED)
find_package(OpenGL REQUIRED)
pkg_search_module(GLFW REQUIRED glfw3)

add_library(imgui OBJECT
        source/imgui.cpp
        source/imgui_demo.cpp
        source/imgui_draw.cpp
        include/misc/freetype/imgui_freetype.cpp # TODO move source and includes in the same directory
        source/imgui_impl_glfw.cpp
        source/imgui_impl_opengl3.cpp
        source/imgui_tables.cpp
        source/imgui_widgets.cpp

        source/TextEditor.cpp

        source/imnodes.cpp

        source/implot.cpp
        source/implot_items.cpp
        source/implot_demo.cpp

        source/fonts/fontawesome_font.c
        source/fonts/codicons_font.c
        source/fonts/unifont_font.c
)

target_compile_definitions(imgui PUBLIC IMGUI_IMPL_OPENGL_LOADER_GLAD)
target_compile_options(imgui PRIVATE -Wno-stringop-overflow)

target_compile_definitions(imgui PUBLIC IMGUI_USER_CONFIG="imgui_config.h")

target_include_directories(imgui PUBLIC include ${FREETYPE_INCLUDE_DIRS} ${GLFW_INCLUDE_DIRS} ${OpenGL_INCLUDE_DIRS})
target_link_directories(imgui PUBLIC ${GLFW_LIBRARY_DIRS} ${OpenGL_LIBRARY_DIRS})
target_link_libraries(imgui PUBLIC Freetype::Freetype ${GLFW_LIBRARIES} ${OPENGL_LIBRARIES})

=== lib/external/miniaudio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(miniaudio)

add_library(miniaudio STATIC
        source/miniaudio.c
)

target_include_directories(miniaudio PUBLIC include)

if (APPLE)
    set_source_files_properties(source/miniaudio.c PROPERTIES LANGUAGE OBJC)
endif ()

=== debian/changelog ===
imhex (1.30.1+ds-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 01:44:54 +0200

imhex (1.30.1+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 1.30.1+ds
  * Refresh patches
  * Update external deps
  * Add informations about debian/external

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 06 Jul 2023 15:47:30 +0200

imhex (1.29.0+ds-0kali3) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * ci: Disable 32bit CI builds

  [ Sophie Brun ]
  * Add autopkgtest

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 23 Jun 2023 11:54:26 +0200

imhex (1.29.0+ds-0kali2) kali-dev; urgency=medium

  * Do not run tests during the build

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 16 Jun 2023 14:46:03 +0200

imhex (1.29.0+ds-0kali1) kali-dev; urgency=medium

  * Initial release. (see 7840)

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 09 Jun 2023 16:27:31 +0200

=== debian/control ===
Source: imhex
Section: misc
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ccache,
 libglfw3-dev, 
 libglm-dev,
 libmagic-dev,
 libmbedtls-dev,
 python3-dev,
 libfreetype-dev,
 libcli11-dev,
 libdbus-1-dev,
 xdg-desktop-portal,
 llvm-dev,
 libyara-dev,
 libfmt-dev,
 libcurl4-openssl-dev,
 nlohmann-json3-dev,
 libimgui-dev,
 libcapstone-dev
Standards-Version: 4.6.2
Homepage: https://github.com/WerWolv/ImHex

Package: imhex
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Recommends: imhex-patterns (>= 1.29.0)
Description: Hex Editor for Reverse Engineers, Programmers
 This package contains a Hex Editor for Reverse Engineers, Programmers and
 people who value their retinas when working at 3 AM.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ #-Scmake


override_dh_auto_configure:
	cp -r debian/external/* lib/external/
	mkdir -p lib/external/pattern_language/external
	cp -r lib/external/libwolv lib/external/pattern_language/external
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_SKIP_RPATH=ON \
		-DUSE_SYSTEM_LLVM=ON \
		-DUSE_SYSTEM_YARA=ON \
		-DUSE_SYSTEM_FMT=ON \
		-DUSE_SYSTEM_CURL=ON \
		-DUSE_SYSTEM_NLOHMANN_JSON=ON \
		-DUSE_SYSTEM_CAPSTONE=ON \
		-DIMHEX_OFFLINE_BUILD=ON \
    		-DIMHEX_IGNORE_BAD_CLONE=ON \
    		-DIMHEX_STRIP_RELEASE=OFF \
		-DIMHEX_DISABLE_UPDATE_CHECK=ON

override_dh_auto_test:
#	tests require network
#	export LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/lib/libimhex && dh_auto_test

override_dh_auto_install:
	dh_auto_install -Xlicenses

## imhex 1.37.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

# Options
option(IMHEX_PLUGINS_IN_SHARE           "Put the plugins in share/imhex/plugins instead of lib[..]/imhex/plugins (Linux only)"  OFF)
option(IMHEX_STRIP_RELEASE              "Strip the release builds"                                                              ON )
option(IMHEX_OFFLINE_BUILD              "Enable offline build"                                                                  OFF)
option(IMHEX_IGNORE_BAD_CLONE           "Disable the bad clone prevention checks"                                               OFF)
option(IMHEX_PATTERNS_PULL_MASTER       "Download latest files from master branch of the ImHex-Patterns repo"                   OFF)
option(IMHEX_IGNORE_BAD_COMPILER        "Allow compiling with an unsupported compiler"                                          OFF)
option(IMHEX_USE_GTK_FILE_PICKER        "Use GTK file picker instead of xdg-desktop-portals (Linux only)"                       OFF)
option(IMHEX_DISABLE_STACKTRACE         "Disables support for printing stack traces"                                            OFF)
option(IMHEX_BUNDLE_DOTNET              "Bundle .NET runtime"                                                                   ON )
option(IMHEX_ENABLE_LTO                 "Enables Link Time Optimizations if possible"                                           OFF)
option(IMHEX_USE_DEFAULT_BUILD_SETTINGS "Use default build settings"                                                            OFF)
option(IMHEX_STRICT_WARNINGS            "Enable most available warnings and treat them as errors"                               ON )
option(IMHEX_STATIC_LINK_PLUGINS        "Statically link all plugins into the main executable"                                  OFF)
option(IMHEX_GENERATE_PACKAGE           "Specify if a native package should be built. (Windows and MacOS only)"                 OFF)
option(IMHEX_ENABLE_UNITY_BUILD         "Enables building ImHex as a unity build."                                              OFF)
option(IMHEX_GENERATE_PDBS              "Enable generating PDB files in non-debug builds (Windows only)"                        OFF)
option(IMHEX_REPLACE_DWARF_WITH_PDB     "Remove DWARF information from binaries when generating PDBS (Windows only)"            OFF)
option(IMHEX_ENABLE_STD_ASSERTS         "Enable debug asserts in the C++ std library. (Breaks Plugin ABI!)"                     OFF)
option(IMHEX_ENABLE_UNIT_TESTS          "Enable building unit tests"                                                            OFF)
option(IMHEX_ENABLE_PRECOMPILED_HEADERS "Enable precompiled headers"                                                            OFF)
option(IMHEX_COMPRESS_DEBUG_INFO        "Compress debug information"                                                            ON )

set(IMHEX_BASE_FOLDER "${CMAKE_CURRENT_SOURCE_DIR}")
set(CMAKE_MODULE_PATH "${IMHEX_BASE_FOLDER}/cmake/modules")

# Optional IDE support
include("${IMHEX_BASE_FOLDER}/cmake/ide_helpers.cmake")

# Basic compiler and cmake configurations
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
include("${IMHEX_BASE_FOLDER}/cmake/build_helpers.cmake")

# Setup project
loadVersion(IMHEX_VERSION IMHEX_VERSION_PLAIN)
setVariableInParent(IMHEX_VERSION ${IMHEX_VERSION})

configureCMake()
project(imhex
        LANGUAGES       C CXX
        VERSION         ${IMHEX_VERSION_PLAIN}
        DESCRIPTION     "The ImHex Hex Editor"
        HOMEPAGE_URL    "https://imhex.werwolv.net"
)
configureProject()

# Add ImHex sources
add_custom_target(imhex_all ALL)

# Make sure project is configured correctly
setDefaultBuiltTypeIfUnset()
detectBadClone()
verifyCompiler()

detectBundledPlugins()

# Add various defines
detectOS()
addDefines()

# Configure packaging and install targets
configurePackingResources()
setUninstallTarget()
addBundledLibraries()

add_subdirectory(lib/libimhex)
add_subdirectory(main)
addPluginDirectories()

# Add unit tests
if (IMHEX_ENABLE_UNIT_TESTS)
    if (NOT TARGET unit_tests)
        enable_testing()
        add_custom_target(unit_tests)
        add_subdirectory(tests EXCLUDE_FROM_ALL)
    endif ()
endif ()

# Configure more resources that will be added to the install package
generateSDKDirectory()

# Handle package generation
createPackage()

# Accommodate IDEs with FOLDER support
tweakTargetsForIDESupport()

=== main/CMakeLists.txt ===
if (WIN32)
    set(IMHEX_APPLICATION_NAME "imhex-gui")
else ()
    set(IMHEX_APPLICATION_NAME "imhex")
endif ()

add_subdirectory(gui)
if (WIN32)
    add_subdirectory(forwarder)
endif ()

if (NOT EMSCRIPTEN)
    add_subdirectory(updater)
endif ()

=== tests/CMakeLists.txt ===
project(unit_tests)

add_subdirectory(common)
target_compile_definitions(tests_common PUBLIC IMHEX_PROJECT_NAME="${PROJECT_NAME}")

add_subdirectory(helpers)
add_subdirectory(algorithms)
add_subdirectory(plugins)

=== lib/libimhex/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(libimhex)

set(CMAKE_CXX_STANDARD 23)

set(LIBIMHEX_SOURCES
        source/api/imhex_api.cpp
        source/api/content_registry.cpp
        source/api/event_manager.cpp
        source/api/task_manager.cpp
        source/api/shortcut_manager.cpp
        source/api/plugin_manager.cpp
        source/api/project_file_manager.cpp
        source/api/theme_manager.cpp
        source/api/layout_manager.cpp
        source/api/workspace_manager.cpp
        source/api/achievement_manager.cpp
        source/api/localization_manager.cpp
        source/api/tutorial_manager.cpp

        source/data_processor/attribute.cpp
        source/data_processor/link.cpp
        source/data_processor/node.cpp

        source/helpers/utils.cpp
        source/helpers/utils_linux.cpp
        source/helpers/fs.cpp
        source/helpers/magic.cpp
        source/helpers/crypto.cpp
        source/helpers/http_requests.cpp
        source/helpers/http_requests_native.cpp
        source/helpers/http_requests_emscripten.cpp
        source/helpers/opengl.cpp
        source/helpers/patches.cpp
        source/helpers/encoding_file.cpp
        source/helpers/logger.cpp
        source/helpers/tar.cpp
        source/helpers/debugging.cpp
        source/helpers/default_paths.cpp
        source/helpers/imgui_hooks.cpp
        source/helpers/semantic_version.cpp
        source/helpers/keys.cpp

        source/test/tests.cpp

        source/providers/provider.cpp
        source/providers/memory_provider.cpp
        source/providers/undo/stack.cpp

        source/ui/imgui_imhex_extensions.cpp
        source/ui/view.cpp
        source/ui/popup.cpp
        source/ui/toast.cpp
        source/ui/banner.cpp

        source/subcommands/subcommands.cpp
)

if (APPLE)
    set(OSX_11_0_SDK_PATH  /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX11.0.sdk)
    if (NOT CMAKE_OSX_SYSROOT)
        if (IS_DIRECTORY ${OSX_11_0_SDK_PATH})
            set(CMAKE_OSX_SYSROOT ${OSX_11_0_SDK_PATH})
        else ()
            message(WARNING "CMAKE_OSX_SYSROOT not set and macOS 10.9 SDK not found! Using default one.")
        endif ()
    endif ()

    set(LIBIMHEX_SOURCES ${LIBIMHEX_SOURCES}
            source/helpers/utils_macos.m
            source/helpers/macos_menu.m
    )
endif ()

if (IMHEX_EXTERNAL_PLUGIN_BUILD)
    add_library(libimhex IMPORTED SHARED GLOBAL)
    set(LIBIMHEX_LIBRARY_TYPE INTERFACE)
else()
    if (IMHEX_STATIC_LINK_PLUGINS)
        add_library(libimhex STATIC ${LIBIMHEX_SOURCES})
    else()
        add_library(libimhex SHARED ${LIBIMHEX_SOURCES})
    endif()

    set(LIBIMHEX_LIBRARY_TYPE PUBLIC)
    target_compile_definitions(libimhex PRIVATE IMHEX_PROJECT_NAME="${PROJECT_NAME}")
endif()


if (DEFINED IMHEX_COMMIT_HASH_LONG AND DEFINED IMHEX_COMMIT_BRANCH)
    set(GIT_COMMIT_HASH_LONG "${IMHEX_COMMIT_HASH_LONG}")
    set(GIT_BRANCH "${IMHEX_COMMIT_BRANCH}")
else()
    # Get the current working branch
    execute_process(
            COMMAND git rev-parse --abbrev-ref HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE GIT_BRANCH
            OUTPUT_STRIP_TRAILING_WHITESPACE
            RESULT_VARIABLE RESULT_BRANCH
            ERROR_QUIET
    )

    execute_process(
            COMMAND git log -1 --format=%H
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE GIT_COMMIT_HASH_LONG
            OUTPUT_STRIP_TRAILING_WHITESPACE
            RESULT_VARIABLE RESULT_HASH_LONG
            ERROR_QUIET
    )
endif ()

if (GIT_COMMIT_HASH_LONG STREQUAL "" OR GIT_BRANCH STREQUAL "")
    message(WARNING "Failed to to determine commit hash/branch")
else()
    addDefineToSource(source/api/imhex_api.cpp "GIT_COMMIT_HASH_LONG=\"${GIT_COMMIT_HASH_LONG}\"")
    addDefineToSource(source/api/imhex_api.cpp "GIT_BRANCH=\"${GIT_BRANCH}\"")
endif ()

addDefineToSource(source/api/imhex_api.cpp "IMHEX_VERSION=\"${IMHEX_VERSION_STRING}\"")

enableUnityBuild(libimhex)
setupCompilerFlags(libimhex)

include(GenerateExportHeader)
generate_export_header(libimhex)

target_include_directories(libimhex ${LIBIMHEX_LIBRARY_TYPE} include ${XDGPP_INCLUDE_DIRS} ${LLVM_INCLUDE_DIRS} ${FMT_INCLUDE_DIRS})

if (NOT IMHEX_EXTERNAL_PLUGIN_BUILD)
    if (WIN32)
        set_target_properties(libimhex PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
        if (NOT MSVC)
            target_link_options(libimhex PRIVATE -Wl,--export-all-symbols)
        endif()
        target_link_libraries(libimhex PRIVATE Netapi32.lib)
        target_compile_definitions(libimhex PRIVATE EXPORT_SYMBOLS=1)
    elseif (APPLE)
        find_library(FOUNDATION NAMES Foundation)
        target_link_libraries(libimhex PUBLIC ${FOUNDATION})
    endif ()

    target_link_libraries(libimhex PRIVATE libpl microtar ${NFD_LIBRARIES} magic)
    target_link_libraries(libimhex PUBLIC libwolv libpl_includes libpl-gen ${IMGUI_LIBRARIES} ${JTHREAD_LIBRARIES})

    if (NOT WIN32)
        target_link_libraries(libimhex PRIVATE dl)
    endif()

    if (NOT EMSCRIPTEN)
        # curl is only used in non-emscripten builds
        target_link_libraries(libimhex ${LIBIMHEX_LIBRARY_TYPE} CURL::libcurl)
    endif()

    target_include_directories(libimhex ${LIBIMHEX_LIBRARY_TYPE} ${MBEDTLS_INCLUDE_DIR} ${LIBBACKTRACE_INCLUDE_DIRS} ${MAGIC_INCLUDE_DIRS})
    target_link_libraries(libimhex ${LIBIMHEX_LIBRARY_TYPE} ${MBEDTLS_LIBRARIES})
    target_link_directories(libimhex ${LIBIMHEX_LIBRARY_TYPE} ${MBEDTLS_LIBRARY_DIR} ${MAGIC_LIBRARY_DIRS})

    precompileHeaders(libimhex "${CMAKE_CURRENT_SOURCE_DIR}/include")
endif()

target_link_libraries(libimhex ${LIBIMHEX_LIBRARY_TYPE} ${NLOHMANN_JSON_LIBRARIES} imgui_all_includes ${FMT_LIBRARIES} ${LUNASVG_LIBRARIES} ${BOOST_LIBRARIES})

set_property(TARGET libimhex PROPERTY INTERPROCEDURAL_OPTIMIZATION FALSE)

add_dependencies(imhex_all libimhex)

install(FILES "$<TARGET_FILE:libimhex>" DESTINATION "${CMAKE_INSTALL_LIBDIR}" PERMISSIONS ${LIBRARY_PERMISSIONS})
set_target_properties(libimhex PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set_target_properties(libimhex PROPERTIES PREFIX "")

=== main/forwarder/CMakeLists.txt ===
project(main-forwarder)

add_executable(main-forwarder
        source/main.cpp
        ${IMHEX_ICON}
)

target_link_libraries(main-forwarder PRIVATE wolv::io ${FMT_LIBRARIES})
add_dependencies(imhex_all main-forwarder)
set_target_properties(main-forwarder PROPERTIES
        OUTPUT_NAME "imhex"
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/../..
)

if (WIN32)
    if (MSVC)
        target_link_options(main-forwarder PRIVATE /MANIFEST:NO)
    endif()
endif()

=== main/gui/CMakeLists.txt ===
project(main)

add_executable(main ${APPLICATION_TYPE}
    source/main.cpp
    source/crash_handlers.cpp
    source/stacktrace.cpp

    source/window/window.cpp
    source/window/win_window.cpp
    source/window/macos_window.cpp
    source/window/linux_window.cpp
    source/window/web_window.cpp

    source/messaging/common.cpp
    source/messaging/linux.cpp
    source/messaging/macos.cpp
    source/messaging/win.cpp
    source/messaging/web.cpp

    source/init/splash_window.cpp
    source/init/tasks.cpp

    source/init/run/common.cpp
    source/init/run/native.cpp
    source/init/run/web.cpp
    source/init/run/cli.cpp

    ${IMHEX_ICON}
)

target_include_directories(main PUBLIC include)
setupCompilerFlags(main)
setupCompilerFlags(libimhex)

set(LIBROMFS_RESOURCE_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/romfs)
set(LIBROMFS_PROJECT_NAME imhex)
add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../../lib/external/libromfs ${CMAKE_CURRENT_BINARY_DIR}/main/gui/libromfs EXCLUDE_FROM_ALL)
add_dependencies(imhex_all main)

if (EMSCRIPTEN)
    target_link_options(main PRIVATE -sUSE_GLFW=3 -sUSE_PTHREADS=1 -sALLOW_MEMORY_GROWTH=1)
    target_link_options(main PRIVATE -sTOTAL_MEMORY=134217728)
    target_link_options(main PRIVATE -sMAX_WEBGL_VERSION=2)
    target_link_options(main PRIVATE -sEXPORTED_RUNTIME_METHODS=ccall)
    target_link_options(main PRIVATE -sFETCH)
    target_link_options(main PRIVATE -sWASM_BIGINT)
    target_link_options(main PRIVATE -O2)
    target_link_options(main PRIVATE -sLEGACY_GL_EMULATION)
    target_link_options(main PRIVATE -fsanitize=null)
    target_link_options(main PRIVATE -fsanitize-minimal-runtime)
    target_link_libraries(main PRIVATE idbfs.js)
endif ()

set_target_properties(main PROPERTIES
    OUTPUT_NAME "${IMHEX_APPLICATION_NAME}"
    RUNTIME_OUTPUT_DIRECTORY "${IMHEX_MAIN_OUTPUT_DIRECTORY}"
)

target_compile_definitions(main PRIVATE IMHEX_PROJECT_NAME="${PROJECT_NAME}")

target_link_libraries(main PRIVATE libromfs-imhex libimhex libwolv ${LIBBACKTRACE_LIBRARIES} LLVMDemangle)
if (WIN32)
    target_link_libraries(main PRIVATE usp10 wsock32 ws2_32 Dwmapi.lib Winmm.lib)

    if (MSVC)
        target_link_options(main PRIVATE /MANIFEST:NO /ENTRY:mainCRTStartup)
    endif()
else ()
    target_link_libraries(main PRIVATE pthread)

    if (NOT APPLE)
        find_package(Fontconfig)
        if (TARGET Fontconfig::Fontconfig)
            message(STATUS "Using Fontconfig version: ${Fontconfig_VERSION}")
            target_link_libraries(main PRIVATE Fontconfig::Fontconfig)
            target_compile_definitions(main PRIVATE IMHEX_HAS_FONTCONFIG)
        endif ()
    endif ()
endif ()

precompileHeaders(main ${CMAKE_CURRENT_SOURCE_DIR}/include)

if (APPLE)
    add_compile_definitions(GL_SILENCE_DEPRECATION)
endif ()

=== main/updater/CMakeLists.txt ===
project(updater) 

add_executable(updater
    source/main.cpp
)

target_compile_definitions(updater PRIVATE IMHEX_PROJECT_NAME="${PROJECT_NAME}")
target_link_libraries(updater PRIVATE libimhex ${FMT_LIBRARIES})
add_dependencies(main updater)
setupCompilerFlags(updater)


set_target_properties(updater PROPERTIES
        OUTPUT_NAME "imhex-updater"
        RUNTIME_OUTPUT_DIRECTORY ${IMHEX_MAIN_OUTPUT_DIRECTORY}
)

=== plugins/builtin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

include(ImHexPlugin)

find_file(DEFAULT_MAGIC_FILE_PATH magic.mgc HINTS ${LIBMAGIC_INCLUDE_DIR}/../share/misc)
if (EXISTS ${DEFAULT_MAGIC_FILE_PATH})
    add_romfs_resource(${DEFAULT_MAGIC_FILE_PATH} always_auto_extract/magic/magic.mgc)
endif ()

add_imhex_plugin(
    NAME
        builtin

    SOURCES
        source/plugin_builtin.cpp

        source/content/background_services.cpp
        source/content/command_palette_commands.cpp
        source/content/command_line_interface.cpp
        source/content/communication_interface.cpp
        source/content/data_inspector.cpp
        source/content/pl_builtin_functions.cpp
        source/content/pl_builtin_types.cpp
        source/content/pl_pragmas.cpp
        source/content/settings_entries.cpp
        source/content/tools_entries.cpp
        source/content/data_processor_nodes.cpp
        source/content/ui_items.cpp
        source/content/providers.cpp
        source/content/views.cpp
        source/content/data_formatters.cpp
        source/content/main_menu_items.cpp
        source/content/welcome_screen.cpp
        source/content/data_visualizers.cpp
        source/content/events.cpp
        source/content/global_actions.cpp
        source/content/themes.cpp
        source/content/recent.cpp
        source/content/file_handlers.cpp
        source/content/project.cpp
        source/content/achievements.cpp
        source/content/file_extraction.cpp
        source/content/report_generators.cpp
        source/content/init_tasks.cpp
        source/content/workspaces.cpp
        source/content/pl_visualizers.cpp
        source/content/out_of_box_experience.cpp
        source/content/minimap_visualizers.cpp
        source/content/window_decoration.cpp
        source/content/data_information_sections.cpp

        source/content/helpers/demangle.cpp

        source/content/data_processor_nodes/basic_nodes.cpp
        source/content/data_processor_nodes/control_nodes.cpp
        source/content/data_processor_nodes/decode_nodes.cpp
        source/content/data_processor_nodes/logic_nodes.cpp
        source/content/data_processor_nodes/math_nodes.cpp
        source/content/data_processor_nodes/other_nodes.cpp
        source/content/data_processor_nodes/visual_nodes.cpp

        source/content/providers/file_provider.cpp
        source/content/providers/gdb_provider.cpp
        source/content/providers/disk_provider.cpp
        source/content/providers/intel_hex_provider.cpp
        source/content/providers/motorola_srec_provider.cpp
        source/content/providers/memory_file_provider.cpp
        source/content/providers/process_memory_provider.cpp
        source/content/providers/base64_provider.cpp
        source/content/providers/view_provider.cpp

        source/content/tools/ascii_table.cpp
        source/content/tools/base_converter.cpp
        source/content/tools/byte_swapper.cpp
        source/content/tools/color_picker.cpp
        source/content/tools/demangler.cpp
        source/content/tools/euclidean_alg.cpp
        source/content/tools/file_tool_shredder.cpp
        source/content/tools/file_tool_splitter.cpp
        source/content/tools/file_tool_combiner.cpp
        source/content/tools/file_uploader.cpp
        source/content/tools/graphing_calc.cpp
        source/content/tools/ieee_decoder.cpp
        source/content/tools/math_eval.cpp
        source/content/tools/multiplication_decoder.cpp
        source/content/tools/perms_calc.cpp
        source/content/tools/regex_replacer.cpp
        source/content/tools/tcp_client_server.cpp
        source/content/tools/wiki_explainer.cpp
        source/content/tools/http_requests.cpp

        source/content/pl_visualizers/hex_viewer.cpp
        source/content/pl_visualizers/chunk_entropy.cpp

        source/content/tutorials/tutorials.cpp
        source/content/tutorials/introduction.cpp

        source/content/popups/hex_editor/popup_hex_editor_find.cpp

        source/content/views/view_hex_editor.cpp
        source/content/views/view_pattern_editor.cpp
        source/content/views/view_pattern_data.cpp
        source/content/views/view_information.cpp
        source/content/views/view_about.cpp
        source/content/views/view_tools.cpp
        source/content/views/view_data_inspector.cpp
        source/content/views/view_bookmarks.cpp
        source/content/views/view_patches.cpp
        source/content/views/view_command_palette.cpp
        source/content/views/view_settings.cpp
        source/content/views/view_data_processor.cpp
        source/content/views/view_constants.cpp
        source/content/views/view_store.cpp
        source/content/views/view_provider_settings.cpp
        source/content/views/view_find.cpp
        source/content/views/view_theme_manager.cpp
        source/content/views/view_logs.cpp
        source/content/views/view_achievements.cpp
        source/content/views/view_highlight_rules.cpp
        source/content/views/view_tutorials.cpp
    INCLUDES
        include

    LIBRARIES
        ui
        fonts
        ${JTHREAD_LIBRARIES}
        plcli
        libpl-gen
        LLVMDemangle
)

if (WIN32)
    target_link_libraries(builtin PRIVATE setupapi)
endif ()

=== plugins/decompress/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

include(ImHexPlugin)

macro(addOptionalLibrary package library)
    find_package(${package})
    if (${package}_FOUND)
        string(TOUPPER ${package} PACKAGE)
        set(LIBRARIES ${LIBRARIES} ${package}::${library})
        message(STATUS "Enabling decompression support using ${package} (${${package}_VERSION})")
        enable_plugin_feature(${PACKAGE})
    endif()

endmacro()

add_imhex_plugin(
    NAME
        decompress
    SOURCES
        source/plugin_decompress.cpp

        source/content/pl_functions.cpp
    INCLUDES
        include
    LIBRARIES
        ui
        fonts
    FEATURES
        ZLIB "ZLib support"
        BZIP2 "Bzip2 support"
        LIBLZMA "LZMA support"
        ZSTD "zstd Support"
        LZ4 "lz4 Support"
)

set(LIBLZMA_HAS_AUTO_DECODER 1)
set(LIBLZMA_HAS_EASY_ENCODER 1)
set(LIBLZMA_HAS_LZMA_PRESET  1)

addOptionalLibrary(ZLIB ZLIB)
addOptionalLibrary(BZip2 BZip2)
addOptionalLibrary(LibLZMA LibLZMA)
addOptionalLibrary(ZSTD zstd)
addOptionalLibrary(LZ4 lz4)
target_link_libraries(decompress PRIVATE ${LIBRARIES})

=== plugins/diffing/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

include(ImHexPlugin)

if (USE_SYSTEM_EDLIB)
    find_package(edlib REQUIRED)
else()
    set(BUILD_TESTING OFF CACHE BOOL "" FORCE)
    add_subdirectory(${THIRD_PARTY_LIBS_FOLDER}/edlib ${CMAKE_CURRENT_BINARY_DIR}/edlib EXCLUDE_FROM_ALL)
    enableUnityBuild(edlib)
    if (MSVC)
        target_compile_options(edlib PRIVATE /wd4244)
    endif ()
endif()

add_imhex_plugin(
    NAME
        diffing
    SOURCES
        source/plugin_diffing.cpp

        source/content/diffing_algorithms.cpp
        source/content/views/view_diff.cpp
    INCLUDES
        include
    LIBRARIES
        ui
        fonts
        edlib
)

=== plugins/disassembler/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

include(ImHexPlugin)

if (NOT USE_SYSTEM_CAPSTONE)
    set(CAPSTONE_BUILD_STATIC_RUNTIME OFF CACHE BOOL "Disable shared library building")
    set(CAPSTONE_BUILD_SHARED OFF CACHE BOOL "Disable shared library building")
    set(CAPSTONE_BUILD_TESTS OFF CACHE BOOL "Disable tests")
    set(CAPSTONE_BUILD_MACOS_THIN ON CACHE BOOL "Enable thin builds of capstone for macOS" FORCE)
    add_subdirectory(${THIRD_PARTY_LIBS_FOLDER}/capstone ${CMAKE_CURRENT_BINARY_DIR}/capstone EXCLUDE_FROM_ALL)
    if (NOT MSVC)
        target_compile_options(capstone PRIVATE -Wno-unused-function)
    else()
        target_compile_options(capstone PRIVATE /wd4005)
    endif()
    set(CAPSTONE_LIBRARY "capstone")
    set(CAPSTONE_INCLUDE_DIR ${THIRD_PARTY_LIBS_FOLDER}/capstone/include)
else()
    find_package(Capstone REQUIRED)
endif()

add_imhex_plugin(
    NAME
        disassembler
    SOURCES
        source/plugin_disassembler.cpp

        source/content/views/view_disassembler.cpp

        source/content/pl_visualizers/disassembler.cpp
        source/content/pl_builtin_types.cpp

        source/content/disassemblers/capstone_architectures.cpp
        source/content/disassemblers/custom_architectures.cpp
    INCLUDES
        include
        ${CAPSTONE_INCLUDE_DIR}
    LIBRARIES
        ui
        fonts
        ${CAPSTONE_LIBRARY}
        libdisassembler
)

=== plugins/hashes/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

include(ImHexPlugin)

add_subdirectory(${THIRD_PARTY_LIBS_FOLDER}/HashLibPlus ${CMAKE_CURRENT_BINARY_DIR}/HashLibPlus)
enableUnityBuild(hashplus)

add_imhex_plugin(
    NAME
        hashes
    SOURCES
        source/plugin_hashes.cpp

        source/content/hashes.cpp

        source/content/views/view_hashes.cpp
    INCLUDES
        include
    LIBRARIES
        fonts
        hashplus
)

=== debian/changelog ===
imhex (1.37.4-0kali1) kali-dev; urgency=medium

  * New upstream version 1.37.4
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 31 Mar 2025 15:41:18 +0200

imhex (1.37.1-0kali2) kali-dev; urgency=medium

  * Remove dotnet* build-deps to fix build on arm64

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 26 Feb 2025 16:16:13 +0100

imhex (1.37.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.37.1
  * Refresh patches
  * Do not handle ImHex-Patterns during the build
  * Update debian/external
  * Add missing build-deps

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 26 Feb 2025 11:18:21 +0100

imhex (1.36.2-0kali1) kali-dev; urgency=medium

  * New upstream version 1.36.2
  * Update debian/external for the latest upstream release

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 06 Jan 2025 16:26:32 +0100

imhex (1.35.4-0kali2) kali-dev; urgency=medium

  * Remove dotnet* build-deps

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 23 Aug 2024 15:52:35 +0200

imhex (1.35.4-0kali1) kali-dev; urgency=medium

  * New upstream version 1.35.4
  * Add new build-deps
  * Update third_party/nativefiledialog

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 23 Aug 2024 11:56:29 +0200

imhex (1.35.3-0kali1) kali-dev; urgency=medium

  * New upstream version 1.35.3
  * Remove useless dirs in debian/third_party/
  * Update debian/external libs

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 05 Jul 2024 10:43:04 +0200

imhex (1.34.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.34.0
  * Refresh patches
  * Update external deps
  * Update autopkgtest

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 11 Jun 2024 13:38:09 +0200

imhex (1.33.2-0kali1) kali-dev; urgency=medium

  * New upstream version 1.33.2
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 26 Mar 2024 17:37:33 +0100

imhex (1.33.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.33.1
  * Refresh patches
  * Add missing lib edlib in third_party
  * Update external libs
  * Remove useless debian/third_party/imgui

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 05 Mar 2024 11:17:40 +0100

imhex (1.32.2-0kali2) kali-dev; urgency=medium

  * Fix build failure

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 12 Jan 2024 11:41:32 +0100

imhex (1.32.2-0kali1) kali-dev; urgency=medium

  * New upstream version 1.32.2
  * Refresh patches
  * Update external libs
  * Remove Werror in pattern_language

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 10 Jan 2024 17:45:51 +0100

imhex (1.31.0+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 1.31.0+ds
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 25 Sep 2023 17:38:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: imhex
 Section: misc
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Sophie Brun <sophie@offensive-security.com>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -17,15 +17,20 @@
  libcli11-dev,
  libdbus-1-dev,
  xdg-desktop-portal,
- llvm-dev,
+# llvm-dev,
  libyara-dev,
  libfmt-dev,
  libcurl4-openssl-dev,
  nlohmann-json3-dev,
  libimgui-dev,
- libcapstone-dev
+ liblzma-dev,
+ libzstd-dev,
+ libcapstone-dev,
+ libxrandr-dev
 Standards-Version: 4.6.2
 Homepage: https://github.com/WerWolv/ImHex
+Vcs-Browser: https://gitlab.com/kalilinux/packages/imhex
+Vcs-Git: https://gitlab.com/kalilinux/packages/imhex.git
 
 Package: imhex
 Architecture: amd64 arm64

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ #-Scmake


override_dh_auto_configure:
	mkdir -p lib/external/pattern_language/external
	cp -r debian/external/* lib/external/
	cp -r debian/third_party/* lib/third_party/
	cp -r lib/external/libwolv lib/external/pattern_language/external
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_SKIP_RPATH=ON \
		-DUSE_SYSTEM_YARA=ON \
		-DUSE_SYSTEM_NLOHMANN_JSON=ON \
		-DUSE_SYSTEM_FMT=ON \
		-DUSE_SYSTEM_CLI11=ON \
		-DIMHEX_OFFLINE_BUILD=ON \
		-DIMHEX_IGNORE_BAD_CLONE=ON \
    		-DIMHEX_STRIP_RELEASE=OFF \
		-DIMHEX_DISABLE_UPDATE_CHECK=ON \
		-DIMHEX_ENABLE_UNIT_TESTS=ON \
		-DIMHEX_STRICT_WARNINGS=OFF

# Disable use system capstone for the system until capstone version 5 is
# in Kali
#		-DUSE_SYSTEM_CAPSTONE=ON \

# Disable usr system llvm
# 		-DUSE_SYSTEM_LLVM=ON \

override_dh_auto_test:
#	tests require network
#	export LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/lib/libimhex && dh_auto_test

override_dh_auto_install:
	dh_auto_install -Xlicenses

override_dh_dwz:

=== debian/tests/control ===
Tests: runtest.sh
Depends: @builddeps@, ca-certificates, imhex
Restrictions: build-needed

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%,\
      dversionmangle=s/\+ds$//,repacksuffix=+ds" \
    https://github.com/WerWolv/ImHex/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
